#define PERL_constant_NOTFOUND	1
#define PERL_constant_NOTDEF	2
#define PERL_constant_ISIV	3
#define PERL_constant_ISNO	4
#define PERL_constant_ISNV	5
#define PERL_constant_ISPV	6
#define PERL_constant_ISPVN	7
#define PERL_constant_ISSV	8
#define PERL_constant_ISUNDEF	9
#define PERL_constant_ISUV	10
#define PERL_constant_ISYES	11

#ifndef NVTYPE
typedef double NV; /* 5.6 and later define NVTYPE, and typedef NV to it.  */
#endif
#ifndef aTHX_
#define aTHX_ /* 5.6 or later define this for threading support.  */
#endif
#ifndef pTHX_
#define pTHX_ /* 5.6 or later define this for threading support.  */
#endif

static int
constant (pTHX_ const char *name, STRLEN len, IV *iv_return) {
  /* Initially switch on the length of the name.  */
  /* When generated this function returned values for the list of names given
     in this section of perl code.  Rather than manually editing these functions
     to add or remove constants, which would result in this comment and section
     of code becoming inaccurate, we recommend that you edit this section of
     code, and use it to regenerate a new set of constant functions which you
     then use to replace the originals.

     Regenerate these constant functions by feeding this entire source file to
     perl -x

#!/usr/bin/perl5.8.8 -w
use ExtUtils::Constant qw (constant_types C_constant XS_constant);

my $types = {map {($_, 1)} qw(IV)};
my @names = (qw(ZVT_BACKGROUND_SCROLL ZVT_BACKGROUND_SHADED ZVT_TERM_DO_LASTLOG
	       ZVT_TERM_DO_UTMP_LOG ZVT_TERM_DO_WTMP_LOG));

print constant_types(); # macro defs
foreach (C_constant ("Foo", 'constant', 'IV', $types, undef, 3, @names) ) {
    print $_, "\n"; # C constant subs
}
print "#### XS Section:\n";
print XS_constant ("Foo", $types);
__END__
   */

  switch (len) {
  case 19:
    if (memEQ(name, "ZVT_TERM_DO_LASTLOG", 19)) {
#ifdef ZVT_TERM_DO_LASTLOG
      *iv_return = ZVT_TERM_DO_LASTLOG;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 20:
    /* Names all of length 20.  */
    /* ZVT_TERM_DO_UTMP_LOG ZVT_TERM_DO_WTMP_LOG */
    /* Offset 12 gives the best switch position.  */
    switch (name[12]) {
    case 'U':
      if (memEQ(name, "ZVT_TERM_DO_UTMP_LOG", 20)) {
      /*                           ^              */
#ifdef ZVT_TERM_DO_UTMP_LOG
        *iv_return = ZVT_TERM_DO_UTMP_LOG;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'W':
      if (memEQ(name, "ZVT_TERM_DO_WTMP_LOG", 20)) {
      /*                           ^              */
#ifdef ZVT_TERM_DO_WTMP_LOG
        *iv_return = ZVT_TERM_DO_WTMP_LOG;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 21:
    /* Names all of length 21.  */
    /* ZVT_BACKGROUND_SCROLL ZVT_BACKGROUND_SHADED */
    /* Offset 16 gives the best switch position.  */
    switch (name[16]) {
    case 'C':
      if (memEQ(name, "ZVT_BACKGROUND_SCROLL", 21)) {
      /*                               ^           */
#ifdef ZVT_BACKGROUND_SCROLL
        *iv_return = ZVT_BACKGROUND_SCROLL;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'H':
      if (memEQ(name, "ZVT_BACKGROUND_SHADED", 21)) {
      /*                               ^           */
#ifdef ZVT_BACKGROUND_SHADED
        *iv_return = ZVT_BACKGROUND_SHADED;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

